#[derive(
    Debug,
    Clone,
    conjure_object::serde::Serialize,
    conjure_object::serde::Deserialize,
    conjure_object::private::DeriveWith
)]
#[serde(crate = "conjure_object::serde")]
#[derive_with(PartialEq, Eq, PartialOrd, Ord, Hash)]
#[conjure_object::private::staged_builder::staged_builder]
#[builder(crate = conjure_object::private::staged_builder, update, inline)]
pub struct SummarizeCartesianNode {
    #[builder(custom(type = super::CartesianNode, convert = Box::new))]
    #[serde(rename = "input")]
    input: Box<super::CartesianNode>,
    #[builder(
        default,
        custom(
            type = impl
            Into<Option<super::CartesianBounds>>,
            convert = |v|v.into().map(Box::new)
        )
    )]
    #[serde(rename = "bounds", skip_serializing_if = "Option::is_none", default)]
    bounds: Option<Box<super::CartesianBounds>>,
    #[builder(default, into)]
    #[serde(rename = "maxPoints", skip_serializing_if = "Option::is_none", default)]
    max_points: Option<i32>,
}
impl SummarizeCartesianNode {
    /// Constructs a new instance of the type.
    #[inline]
    pub fn new(input: super::CartesianNode) -> Self {
        Self::builder().input(input).build()
    }
    #[inline]
    pub fn input(&self) -> &super::CartesianNode {
        &*self.input
    }
    #[inline]
    pub fn bounds(&self) -> Option<&super::CartesianBounds> {
        self.bounds.as_ref().map(|o| &**o)
    }
    #[inline]
    pub fn max_points(&self) -> Option<i32> {
        self.max_points.as_ref().map(|o| *o)
    }
}
